#region Copyright Syncfusion Inc. 2001 - 2014
// Copyright Syncfusion Inc. 2001 - 2014. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using System.Diagnostics;
using Syncfusion.Windows.Forms;
using Syncfusion.GridHelperClasses;
using Syncfusion.Drawing;


namespace RecursiveNestedCollection
{
    public partial class Form1 : Form
    {
      //  CheckBox checkBox = new CheckBox();   
        public Form1()
        {
            DataTable dt = GetTable();

         
            //Customize the engine to hide the empty child tables.
            GridEngineFactory.Factory = new GroupingEngineFactory();
            InitializeComponent();
            GridExcelFilter filter;
            //Setup Grid
            
            
            gridGroupingControl1.DataSource = dt;
            
            this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = true;
            this.gridGroupingControl1.ChildGroupOptions.ShowCaption = true;
           
            this.gridGroupingControl1.ShowGroupDropArea = true;
            this.gridGroupingControl1.Table.ExpandAllRecords();
            filter = new GridExcelFilter();
            foreach (GridColumnDescriptor col in this.gridGroupingControl1.TableDescriptor.Columns)
            {
                col.AllowFilter = true;
            }
            
            filter.WireGrid(gridGroupingControl1);

            this.gridGroupingControl1.TableOptions.ShowTableIndent = false;
            this.gridGroupingControl1.ShowGroupDropArea = true;
           this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
        }
        private int rows = 50;
        private DataTable GetTable()
        {
            DataTable dt = new DataTable("Sample");
            dt.Columns.Add(new DataColumn("Value1")); //lower case p
            dt.Columns.Add(new DataColumn("Value2", typeof(double)));
            dt.Columns.Add(new DataColumn("Value3", typeof(double)));
            dt.Columns.Add(new DataColumn("Value4", typeof(double)));

            Random r = new Random();
            for (int i = 0; i < rows; ++i)
            {
                DataRow dr = dt.NewRow();
                if (i % 2 == 0)
                {
                    dr[0] = "Row" + (i + 1);
                }
                else
                {
                    dr[0] = "Row";
                }
                dr[2] = r.Next(100);
                dr[1] = r.Next(100);
                dr[3] = r.Next(100);
                //  dr[2] = 10;
                //    dr[1] = 20;
                //    dr[3] = 30;
                ////}

                dt.Rows.Add(dr);
            }
            return dt;
        }
		#region DataTables

		private int numberParentRows = 4;
		private int numberChildRows = 4;
		private int numberGrandChildRows = 4;
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));

			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			dt.Columns.Add(new DataColumn("other")); //upper case P
			dt.Columns.Add(new DataColumn("otherx")); //upper case P
			
			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				dr[3] = string.Format("other{0}",i);
				dr[4] = string.Format("otherx{0}",i);
				dt.Rows.Add(dr);
			}
		
			return dt;
		}

		private DataTable GetGrandChildTable()
		{
			DataTable dt = new DataTable("GrandChildTable");

			dt.Columns.Add(new DataColumn("GrandChildID"));
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ChildID")); //upper case C
			
			for(int i = 0; i < numberGrandChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("GrandChildName{0}",i);
				dr[2] = (i % numberChildRows).ToString();
				dt.Rows.Add(dr);
			}
			
			return dt;
		}
		#endregion

       

        
        // QueryCellStyleInfo event
        void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            if (e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.Column.Name == "Property1")
            {
                // set the celltype as checkbox in column 1
                e.Style.CellType = GridCellTypeName.CheckBox;
                e.Style.Description = e.Style.Text;
                e.Style.CellValueType = typeof(bool);
                e.Style.CellValue = true;
            }
        }

    }
}